=== ElmerGUI/matc/CMakeLists.txt ===
#PROJECT(matc C)

FILE(GLOB SOURCES "src/*.c")
#MESSAGE(STATUS "SOURCES: ${SOURCES}")

IF(NOT(WITH_ELMERGUI))
  ADD_LIBRARY(matc ${SOURCES})
  INSTALL(TARGETS matc RUNTIME DESTINATION "bin" LIBRARY DESTINATION "lib"
    ARCHIVE DESTINATION "lib" COMPONENT "elmergui")
ENDIF()
