=== contrib/lua-5.1.5/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(lua C)
add_subdirectory(src)
